VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsResize"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'###################################################################
'#     VB@RCHIV - Das groe Visual-Basic Archiv
'###################################################################
'#
'#     Datei: clsResize.cls       Autor: Wolfgang Christ
'#     Stand: 11.06.2003          Erstanlage: 29.04.2003
'#
'###################################################################
'#
'#     Version : V1.0.9 * (c) Wolfgang Christ
'#
'###################################################################
'#
'#     Resize ActiveX DLL
'#     Class clsResize
'#
'###################################################################
'#
'#     Diese Klasse steuert die Grenanpassung aller Controls

' vb@rchiv - Das groe Visual-Basic Archiv
' Tools & Components - Entwicklerkomponenten fr VB-32 Bit
'
' Copyright 2003 Wolfgang Christ, Dieter Otter
'
' Der Programmcode darf fr eigene Zwecke verwendet werden.
' Es ist nicht erlaubt Inhalte des Projektes ohne unsere
' Zustimmung zum Download anzubieten.
'
' Die Beispielskripte sind Computerprogramme, die gem
' des 2 Abs. 1 Nr. 69 aff. UrhG den urheberrechtlichen
' Schutz geniessen und drfen nicht fr eigene ausgegeben
' werden.
'
' Dieter Otter
' Software-Entwicklung & Vertrieb
' info@vbarchiv.de
' http://www.vbarchiv.de
' http://www.visualbasic-archiv.de
'
' info@tools4vb.de
' http://www.tools4vb.de
'======================================================

Option Explicit

Private oControls As col_Controls
Private oForm_First As clsForm
Private oForm_Now As Form
Private mvar_ScaleMinMax As Single

Public Enum eToResizeOption
   eToRO_FullResize = 0
   eToR0_Width = 1
   eToR0_Height = 2
   eToRO_WidthHeight = 3
End Enum

Private Sub Class_Initialize()
  'Anlegen der Objekte
  Set oControls = New col_Controls
  Set oForm_First = New clsForm
End Sub

Private Sub Class_Terminate()
  'Zerstren der Objekte
  Set oControls = Nothing
  Set oForm_First = Nothing
  Set oForm_Now = Nothing
End Sub

Public Property Let oForm(ByRef vData As Variant)
  Set oForm_Now = vData
End Property

Public Sub Initialize()
  'Initialisieren
  
  Dim oControl As Control
  Dim mCol_SSTAB As Collection
  Dim sControlName As String
  Dim iFontSize As Single
  Dim lTag As Long
  
  With oForm_First
    .Height = oForm_Now.Height
    .Width = oForm_Now.Width
    .Top = oForm_Now.Top
    .Left = oForm_Now.Left
  End With
  
  Set mCol_SSTAB = New Collection
  
  'Alle Controls durchlaufen und Eigenschaften speichern
  For Each oControl In oForm_Now.Controls
    On Error Resume Next
    
    'SSTAB vom SSTAB verborgene Controls merken und in den sichtbaren
    'Bereich verschieben
    If oControl.Left < 0 Then
      mCol_SSTAB.Add oControl
      oControl.Left = oControl.Left + 75000
    End If
    
    With oControl
      sControlName = oControl.Name
      sControlName = sControlName & CStr(oControl.Index)
      iFontSize = 0
      Err.Clear
      iFontSize = oControl.Fontsize
      If Err.Number = 438 Then iFontSize = oControl.Font.Size
      If TypeOf oControl Is Line Then
         lTag = oControls.AddLine(.X1, .X2, .Y1, .Y2, sControlName).Tag
        Else
         lTag = oControls.Add(.Top, .Left, .Width, .Height, sControlName, iFontSize).Tag
      End If
    End With
  Next
  
  'Alle vorher verschobenen Controls wieder zurckverschieben
  For Each oControl In mCol_SSTAB
    oControl.Left = oControl.Left - 75000
  Next
  
End Sub


Public Sub DoResize()
  'Etwaige Fehler wie bei Timern usw. bergehen
  On Error Resume Next
  
  Dim oControl As Control
  Dim mCol_SSTAB As Collection
  Dim sngFaktor_Height As Single
  Dim sngFaktor_Width As Single
  Dim sngFaktor_FontSize As Single
  Dim sControlName As String
  
  'Controls welche vom SSTAB nach links verschoben sind
  Set mCol_SSTAB = New Collection
  
  'Faktor der Grenvernderung der Breite berechnen
  sngFaktor_Width = oForm_Now.Width / oForm_First.Width
  
  'Faktor der Grenvernderung der Hhe berechnen
  sngFaktor_Height = oForm_Now.Height / oForm_First.Height
  
  'Faktor der Grenvernderung der Schrift
  sngFaktor_FontSize = Min(sngFaktor_Width, sngFaktor_Height)
  
  'nur skalieren, wenn neues Greverhltnis +- ScaleMinMax (z.B. 10%)
  If sngFaktor_Width < 1 - ScaleMinMax / 100 Or sngFaktor_Width > 1 + ScaleMinMax / 100 Or _
    sngFaktor_Height < 1 - ScaleMinMax / 100 Or sngFaktor_Height > 1 + ScaleMinMax / 100 Then
    
    'Alle Controls durchlaufen und der Gre nach anpassen
    For Each oControl In oForm_Now.Controls
        
        'SSTAB - Behandlung
        'Wenn Left - Eigenschaft < 0 ist, dann Control zustzlicher Collection hinzufgen
        If oControl.Left < 0 Then
          mCol_SSTAB.Add oControl
          'oControl.Left = oControl.Left + 75000
        End If
        
        sControlName = oControl.Name
        sControlName = sControlName & CStr(oControl.Index)
          
        If oControls.Item(sControlName).FontSizing = True Then
          Err.Clear
          oControl.Fontsize = oControls.Item(sControlName).Fontsize * sngFaktor_FontSize
          If Err.Number = 438 Then oControl.Font.Size = oControls.Item(sControlName).Fontsize * sngFaktor_FontSize
        End If
          
        'Die Move Methode wird nicht von der
        'ComboBox und DriveListBox untersttzt.
        If (TypeOf oControl Is ComboBox Or _
            TypeOf oControl Is DriveListBox) Then
            
          Select Case oControls.Item(sControlName).ResizeOption
           Case 1 'Breite nicht anpassen
            oControl.Top = oControls.Item(sControlName).Top * sngFaktor_Height
            oControl.Left = oControls.Item(sControlName).Left * sngFaktor_Width
            oControl.Width = oControls.Item(sControlName).Width
            oControl.Height = oControls.Item(sControlName).Height * sngFaktor_Height
           Case 2 'Hhe nicht anpassen
            oControl.Top = oControls.Item(sControlName).Top * sngFaktor_Height
            oControl.Left = oControls.Item(sControlName).Left * sngFaktor_Width
            oControl.Width = oControls.Item(sControlName).Width * sngFaktor_Width
            oControl.Height = oControls.Item(sControlName).Height
           Case 3 'Hhe und Breite nicht anpassen
            oControl.Top = oControls.Item(sControlName).Top * sngFaktor_Height
            oControl.Left = oControls.Item(sControlName).Left * sngFaktor_Width
            oControl.Width = oControls.Item(sControlName).Width
            oControl.Height = oControls.Item(sControlName).Height
           Case Else
            oControl.Top = oControls.Item(sControlName).Top * sngFaktor_Height
            oControl.Left = oControls.Item(sControlName).Left * sngFaktor_Width
            oControl.Width = oControls.Item(sControlName).Width * sngFaktor_Width
            oControl.Height = oControls.Item(sControlName).Height * sngFaktor_Height
          End Select
              
        'Sonderfall Line-Element, da anders definiert
        ElseIf (TypeOf oControl Is Line) Then
            oControl.X1 = oControls.Item(sControlName).X1 * sngFaktor_Width
            oControl.X2 = oControls.Item(sControlName).X2 * sngFaktor_Width
            oControl.Y1 = oControls.Item(sControlName).Y1 * sngFaktor_Height
            oControl.Y2 = oControls.Item(sControlName).Y2 * sngFaktor_Height
              
        ' alle anderen Controls
        Else
          Select Case oControls.Item(sControlName).ResizeOption
           Case 1 'Breite nicht anpassen
            oControl.Move _
               oControls.Item(sControlName).Left * sngFaktor_Width, _
               oControls.Item(sControlName).Top * sngFaktor_Height, _
               oControls.Item(sControlName).Width, _
               oControls.Item(sControlName).Height * sngFaktor_Height
           Case 2 'Hhe nicht anpassen
            oControl.Move _
               oControls.Item(sControlName).Left * sngFaktor_Width, _
               oControls.Item(sControlName).Top * sngFaktor_Height, _
               oControls.Item(sControlName).Width * sngFaktor_Width, _
               oControls.Item(sControlName).Height
           Case 3 'Breite und Hhe nicht anpassen
            oControl.Move _
               oControls.Item(sControlName).Left * sngFaktor_Width, _
               oControls.Item(sControlName).Top * sngFaktor_Height, _
               oControls.Item(sControlName).Width, _
               oControls.Item(sControlName).Height
           Case Else
            oControl.Move _
               oControls.Item(sControlName).Left * sngFaktor_Width, _
               oControls.Item(sControlName).Top * sngFaktor_Height, _
               oControls.Item(sControlName).Width * sngFaktor_Width, _
               oControls.Item(sControlName).Height * sngFaktor_Height
          End Select
        End If
      Next
      
      'SSTAB Controls wieder nach links verschieben
      For Each oControl In mCol_SSTAB
         oControl.Left = oControl.Left - 75000
      Next
      
  Else
    DoResize_First False
  End If
End Sub

'Ursprungszustand wieder herstellen
Public Sub DoResize_First(ByVal bWithForm As Boolean)
  'Etwaige Fehler wie bei Timern usw. bergehen
  On Error Resume Next
  
  Dim oControl As Control
  Dim mCol_SSTAB As Collection
  Dim sngFaktor_Height As Single
  Dim sngFaktor_Width As Single
  Dim sControlName As String
  
  'Controls welche vom SSTAB nach links verschoben sind
  Set mCol_SSTAB = New Collection
  
  'Faktor der Grenvernderung der Breite berechnen
  sngFaktor_Width = 1
  
  'Faktor der Grenvernderung der Hhe berechnen
  sngFaktor_Height = 1
  
  'Alle Controls durchlaufen und der Gre nach anpassen
  For Each oControl In oForm_Now.Controls
      
      Debug.Print oControl.Name
      
      'SSTAB - Behandlung
      'Wenn Left - Eigenschaft < 0 ist, dann Control zustzlicher Collection hinzufgen
      If oControl.Left < 0 Then
        mCol_SSTAB.Add oControl
        'oControl.Left = oControl.Left + 75000
      End If
      
      sControlName = oControl.Name
      sControlName = sControlName & CStr(oControl.Index)
      
      Err.Clear
      oControl.Fontsize = oControls.Item(sControlName).Fontsize
      If Err.Number = 438 Then oControl.Font.Size = oControls.Item(sControlName).Fontsize

      'Die Move Methode wird nicht von der
      'ComboBox und DriveListBox untersttzt.
      If (TypeOf oControl Is ComboBox Or _
          TypeOf oControl Is DriveListBox) Then
          
          oControl.Top = oControls.Item(sControlName).Top * sngFaktor_Height
          oControl.Left = oControls.Item(sControlName).Left * sngFaktor_Width
          oControl.Width = oControls.Item(sControlName).Width * sngFaktor_Width
          oControl.Height = oControls.Item(sControlName).Height * sngFaktor_Height
            
      'Sonderfall Line-Element, da anders definiert
      ElseIf (TypeOf oControl Is Line) Then
          oControl.X1 = oControls.Item(sControlName).X1 * sngFaktor_Width
          oControl.X2 = oControls.Item(sControlName).X2 * sngFaktor_Width
          oControl.Y1 = oControls.Item(sControlName).Y1 * sngFaktor_Height
          oControl.Y2 = oControls.Item(sControlName).Y2 * sngFaktor_Height
            
      'alle anderen Controls
      Else
         oControl.Move _
             oControls.Item(sControlName).Left * sngFaktor_Width, _
             oControls.Item(sControlName).Top * sngFaktor_Height, _
             oControls.Item(sControlName).Width * sngFaktor_Width, _
             oControls.Item(sControlName).Height * sngFaktor_Height
      End If
  Next
      
  'SSTAB Controls wieder nach links verschieben
  For Each oControl In mCol_SSTAB
    'If oControl.Left > 0 Then oControl.Left = oControl.Left - 75000
    oControl.Left = oControl.Left - 75000
  Next
      
  'zu guter Letzt Gre der Form wieder herstellen
  If bWithForm Then
   oForm_Now.Height = oForm_First.Height
   oForm_Now.Width = oForm_First.Width
  End If
  
End Sub


'Funktion setzt ResizeAttribute zu einzelnen Controls der Form
Public Sub ResizeOption(xControl As Control, Optional iResizeOption As eToResizeOption = eToRO_FullResize, Optional bFontSizing = True)
  Dim sControlName As String
  On Error Resume Next
  sControlName = xControl.Name
  sControlName = sControlName & CStr(xControl.Index)
  oControls.Item(sControlName).ResizeOption = iResizeOption
  oControls.Item(sControlName).FontSizing = bFontSizing
End Sub

'Funktion liefert Minimum zweier Gleitkommazahlen einfacher Genauigkeit
Private Function Min(ByVal x As Single, ByVal y As Single) As Single
  If x <= y Then Min = x Else Min = y
End Function

Public Property Get ScaleMinMax() As Single
  ScaleMinMax = mvar_ScaleMinMax
End Property

Public Property Let ScaleMinMax(ByVal vNewValue As Single)
  mvar_ScaleMinMax = vNewValue
End Property
